import sys
forge = sys.modules["forge"]
import os.path

def setup(module):

	deplibs =	forge.corelibs+ [
				"feSignalLib",
				"fexGeometryDLLib",
				"fexDataToolDLLib",
				"fexMathLib" ]

	tests = [	'xMatrixPower',
				'xMatrixSqrt',
				'xSpline' ]

	forge.tests += [
		("xMatrixPower.exe",	"",							None,		None),
		("xMatrixSqrt.exe",		"",							None,		None),
		("xSpline.exe",			"",							None,		None) ]

	if 'viewer' in forge.module_list and os.path.exists('ext/viewer'):
		deplibs += [ "fexViewerDLLib" ]

		tests += [	'xTriangle',
					'xTurtle' ]

		forge.tests += [
			("xTriangle.exe",		"10",					None,		None),
			("xTurtle.exe",			"100",					None,		None) ]
	else:
		forge.color_on(0, forge.BLUE)
		sys.stdout.write("-viewer ")
		forge.color_off()

	for t in tests:
		module.Exe(t)
		forge.deps([t + "Exe"], deplibs)
